Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time.field
Class ScaledDurationField

    java.lang.Object
      org.joda.time.DurationField
          org.joda.time.field.BaseDurationField
              org.joda.time.field.DecoratedDurationField
                  org.joda.time.field.ScaledDurationField

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable

    public class ScaledDurationField

extends DecoratedDurationField

Scales a DurationField such that it's unit millis becomes larger in magnitude.

ScaledDurationField is thread-safe and immutable.

Since:
  1.0
Author:
  Brian S O'Neill
See Also:
  `PreciseDurationField`, Serialized Form

Constructor Summary
`ScaledDurationField(DurationField field, DurationFieldType type, int scalar)` Constructor

Method Summary
`long` | `add(long instant, int value)` Adds a duration value (which may be negative) to the instant.
`long` | `add(long instant, long value)` Adds a duration value (which may be negative) to the instant.
`boolean` | `equals(java.lang.Object obj)` Compares this duration field to another.
`int` | `getDifference(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`long` | `getDifferenceAsLong(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`long` | `getMillis(int value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`long` | `getMillis(int value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`long` | `getMillis(long value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`long` | `getMillis(long value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`int` | `getScalar()` Returns the scalar applied, in the field's units.
`long` | `getUnitMillis()` Returns the amount of milliseconds per unit value of this field.
`int` | `getValue(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`int` | `getValue(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`long` | `getValueAsLong(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`long` | `getValueAsLong(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`int` | `hashCode()` Gets a hash code for this instance.

Methods inherited from class org.joda.time.field.DecoratedDurationField
`getWrappedField, isPrecise`

Methods inherited from class org.joda.time.field.BaseDurationField
`compareTo, getName, getType, isSupported, toString`

Methods inherited from class org.joda.time.DurationField
`subtract, subtract`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ScaledDurationField

    public ScaledDurationField(DurationField field,
                               DurationFieldType type,
                               int scalar)

  Constructor

  Parameters:
    `field` - the field to wrap, like "year()".
    `type` - the type this field will actually use
    `scalar` - scalar, such as 100 years in a century
  Throws:
    `java.lang.IllegalArgumentException` - if scalar is zero or one.

Method Detail

### getValue

    public int getValue(long duration)

  Description copied from class: `BaseDurationField`
  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Overrides:
    `getValue` in class `BaseDurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValueAsLong

    public long getValueAsLong(long duration)

  Description copied from class: `BaseDurationField`
  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Overrides:
    `getValueAsLong` in class `BaseDurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValue

    public int getValue(long duration,
                        long instant)

  Description copied from class: `BaseDurationField`
  Get the value of this field from the milliseconds relative to an instant.

  If the milliseconds is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  The default implementation returns `Utils.safeToInt(getAsLong(millisDuration, instant))`.

  Overrides:
    `getValue` in class `BaseDurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValueAsLong

    public long getValueAsLong(long duration,
                               long instant)

  Description copied from class: `DurationField`
  Get the value of this field from the milliseconds relative to an instant. For precise fields this method produces the same result as for the single argument get method.

  If the millisecond duration is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Overrides:
    `getValueAsLong` in class `DecoratedDurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative

### getMillis

    public long getMillis(int value)

  Description copied from class: `BaseDurationField`
  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Overrides:
    `getMillis` in class `BaseDurationField`
  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getMillis

    public long getMillis(long value)

  Description copied from class: `BaseDurationField`
  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Overrides:
    `getMillis` in class `BaseDurationField`
  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getMillis

    public long getMillis(int value,
                          long instant)

  Description copied from class: `DurationField`
  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Overrides:
    `getMillis` in class `DecoratedDurationField`
  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### getMillis

    public long getMillis(long value,
                          long instant)

  Description copied from class: `DurationField`
  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Overrides:
    `getMillis` in class `DecoratedDurationField`
  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### add

    public long add(long instant,
                    int value)

  Description copied from class: `DurationField`
  Adds a duration value (which may be negative) to the instant.

  Overrides:
    `add` in class `DecoratedDurationField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### add

    public long add(long instant,
                    long value)

  Description copied from class: `DurationField`
  Adds a duration value (which may be negative) to the instant.

  Overrides:
    `add` in class `DecoratedDurationField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### getDifference

    public int getDifference(long minuendInstant,
                             long subtrahendInstant)

  Description copied from class: `DurationField`
  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       int v = ...
       int age = getDifference(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Overrides:
    `getDifference` in class `BaseDurationField`
  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### getDifferenceAsLong

    public long getDifferenceAsLong(long minuendInstant,
                                    long subtrahendInstant)

  Description copied from class: `DurationField`
  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       long v = ...
       long age = getDifferenceAsLong(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Overrides:
    `getDifferenceAsLong` in class `DecoratedDurationField`
  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### getUnitMillis

    public long getUnitMillis()

  Description copied from class: `DurationField`
  Returns the amount of milliseconds per unit value of this field. For example, if this field represents "seconds", then this returns the milliseconds in one second.

  For imprecise fields, the unit size is variable, and so this method returns a suitable average value.

  Overrides:
    `getUnitMillis` in class `DecoratedDurationField`
  Returns:
    the unit size of this field, in milliseconds
  See Also:
    `DurationField.isPrecise()`

### getScalar

    public int getScalar()

  Returns the scalar applied, in the field's units.

  Returns:
    the scalar

### equals

    public boolean equals(java.lang.Object obj)

  Compares this duration field to another. Two fields are equal if of the same type and duration.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to compare to
  Returns:
    if equal

### hashCode

    public int hashCode()

  Gets a hash code for this instance.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    a suitable hashcode

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD